<script setup lang="ts">
import { onMounted, reactive, computed } from 'vue'
import { useDataStore } from '@/store/data'
import API from '@/scripts/api'
import { useAppStore } from '@/store/app'
import { BatchAction } from '@/scripts/types'

const data = useDataStore()
const app = useAppStore()
const state = reactive({
  loading: true,
  lastUpdatedAt: null as null|string,
  debugMode: localStorage.getItem('debug') != null,
  search: ''
})

const generateModalState = reactive({
  displayed: false,
  quantity: 50
})

const batchModalState = reactive({
  displayed: false,
  action: 'activate' as BatchAction,
  from: 0,
  to: 0
})

const headers = [
  {
    title: 'ID du ticket',
    align: 'center',
    key: 'id'
  },
  {
    title: 'Code',
    align: 'start',
    key: 'code'
  },
  {
    title: 'Activé ?',
    align: 'center',
    key: 'activated'
  },
  {
    title: 'SCIPER associé ?',
    align: 'center',
    key: 'user_sciper'
  }
]

const batchActionsItems = [
  {
    label: 'Activer',
    value: 'activate'
  },
  {
    label: 'Désactiver',
    value: 'deactivate'
  },
  {
    label: 'Supprimer les associations',
    value: 'clear_bindings'
  }
] as { label: string, value: BatchAction }[]

onMounted(() => {
  refresh()
})

function refresh() {
  state.loading = true
  data.refreshTickets().finally(() => {
    state.loading = false
    const d = new Date()
    state.lastUpdatedAt = d.toLocaleTimeString('FR-fr')
  })
}

function updateActivated(ticketId: number, activated: boolean) {
  API.operatorUpdateTicketActivated(ticketId, activated).then(refresh)
}

function updateSciper(ticketId: number, sciper: string) {
  if (sciper.length !== 6) return
  API.operatorUpdateTicketSciper(ticketId, sciper).then(() => {
    app.notification('success', `Ticket n°${ticketId} = ${sciper}`)
    refresh()
  })
}

function updateCode(ticketId: number, code: string) {
  if (code.length === 0) return
  API.operatorUpdateTicketCode(ticketId, code).then(() => {
    app.notification('success', `Code of ticket n°${ticketId} updated !`)
    refresh()
  })
}

function generateTickets() {
  API.operatorTicketsGeneration(generateModalState.quantity).then(() => {
    app.notification('success', `${generateModalState.quantity} tickets générés`)
    refresh()
    generateModalState.displayed = false
  }).catch(err => {
    console.error(err)
  })
}

const canExecuteBatchAction = computed(() => {
  return batchModalState.displayed &&
    batchModalState.action.length > 0 &&
    batchModalState.from >= 1 &&
    batchModalState.from <= batchModalState.to
})

function executeBatchAction() {
  API.operatorBatchAction(batchModalState.action, batchModalState.from, batchModalState.to).then(() => {
    app.notification('success', 'Tickets modifiés')
    refresh()
    batchModalState.displayed = false
  }).catch(err => {
    console.error(err)
  })
}
</script>

<template>
  <div class="px-5">
    <div class="flex flex-col sm:flex-row items-center">
      <h2 class="text-xl">Liste des tickets de présence</h2>
      <h5 v-if="state.lastUpdatedAt" class="sm:ml-5">MàJ: {{ state.lastUpdatedAt }}</h5>
    </div>
    <div class="flex flex-col sm:flex-row items-center mt-3">
      <v-text-field
        density="compact"
        variant="solo"
        label="Recherche"
        append-inner-icon="mdi-magnify"
        single-line
        hide-details
        v-model="state.search"
      />
      <div class="flex flex-col sm:flex-row mt-2 sm:mt-0">
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="primary" variant="tonal" size="small" @click="refresh" :loading="state.loading">Actualiser</v-btn>
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="warning" variant="tonal" size="small" @click="() => generateModalState.displayed = true">Générer des tickets</v-btn>
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="warning" variant="tonal" size="small" @click="() => batchModalState.displayed = true">Batch Actions</v-btn>
      </div>
    </div>

    <v-dialog v-model="generateModalState.displayed" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Génération de tickets</span>
        </v-card-title>

        <v-card-text>
          <v-text-field title="Quantité" type="number" v-model.number="generateModalState.quantity"/>
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn variant="text" @click="() => generateModalState.displayed = false">
            Annuler
          </v-btn>
          <v-btn color="success" variant="text" @click="generateTickets">
            Executer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="batchModalState.displayed" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Batch Actions</span>
        </v-card-title>

        <v-card-text>
          <v-select :items="batchActionsItems" v-model="batchModalState.action" item-title="label" item-value="value" />
          <div class="flex">
            <v-text-field placeholder="From" type="number" v-model.number="batchModalState.from" class="mr-2"/>
            <v-text-field placeholder="To" type="number" v-model.number="batchModalState.to" class="ml-2"/>
          </div>
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn variant="text" @click="() => batchModalState.displayed = false">
            Annuler
          </v-btn>
          <v-btn :disabled="!canExecuteBatchAction" color="success" variant="text" @click="executeBatchAction">
            Executer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-data-table :headers="headers" :items="data.tickets" :sort-by="[{ key: 'id', order: 'asc' }]" class="elevation-1 mt-3" :loading="state.loading" :search="state.search">

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.code="{ item }">
        <div class="flex items-baseline">
          <v-text-field v-model="item.raw.code" :class="state.debugMode ? 'min-w-[350px] mt-2' : 'mt-2'" :readonly="state.debugMode" @update:model-value="updateCode(item.raw.id, item.raw.code)"/>
        </div>
      </template>

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.activated="{ item }">
        <v-checkbox-btn
          v-model="item.raw.activated"
          @update:model-value="updateActivated(item.raw.id, item.raw.activated)"
        ></v-checkbox-btn>
      </template>

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.user_sciper="{ item }">
        <div class="flex items-baseline">
          <v-text-field
            v-model="item.raw.user_sciper"
            class="min-w-[100px] mt-2"
            append-icon="mdi-content-save"
            @click:append="updateSciper(item.raw.id, item.raw.user_sciper)" />
        </div>
      </template>

    </v-data-table>
  </div>
</template>
